#ifndef PATCHFINDER64_H_
#define PATCHFINDER64_H_

#import "common.h"
#import <mach/mach.h>

int init_patchfinder(const char *filename);
void term_kernel(void);

enum { SearchInCore, SearchInPrelink };

uint64_t find_register_value(uint64_t where, int reg);
uint64_t find_reference(uint64_t to, int n, int prelink);
uint64_t find_strref(const char *string, int n, int prelink);
uint64_t find_gPhysBase(void);
uint64_t find_kernel_pmap(void);
uint64_t find_amfiret(void);
uint64_t find_ret_0(void);
uint64_t find_amfi_memcmpstub(void);
uint64_t find_sbops(void);
uint64_t find_lwvm_mapio_patch(void);
uint64_t find_lwvm_mapio_newj(void);

uint64_t find_entry(void);
const unsigned char *find_mh(void);

uint64_t find_cpacr_write(void);
uint64_t find_str(const char *string);
uint64_t find_amfiops(void);
uint64_t find_sysbootnonce(void);
uint64_t find_trustcache(void);
uint64_t find_amficache(void);

uint64_t find_trustcache_electra(void);
uint64_t find_amficache_electra(void);

int init_kernel(uint64_t base, const char *filename);

uint64_t find_allproc(void);
uint64_t find_boot_args(unsigned* cmdline_offset);

//electra stuffs

uint64_t find_add_x0_x0_0x40_ret(void);
uint64_t find_allproc_electra(void);
uint64_t find_copyout_electra(void);
uint64_t find_bzero_electra(void);
uint64_t find_bcopy_electra(void);
uint64_t find_trustcache_electra(void);
uint64_t find_amficache_electra(void);
uint64_t find_rootvnode(void);
uint64_t find_zone_map_ref(void);

#endif
