//
//  ViewController.h
//  meridianTV
//
//  Created by Kevin Bradley on 6/24/18.
//  Copyright © 2018 Ben Sparkes. All rights reserved.
//

#define SYSTEM_VERSION_EQUAL_TO(v)                  ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] == NSOrderedSame)
#define SYSTEM_VERSION_GREATER_THAN(v)              ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] == NSOrderedDescending)
#define SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(v)  ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] != NSOrderedAscending)
#define SYSTEM_VERSION_LESS_THAN(v)                 ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] == NSOrderedAscending)
#define SYSTEM_VERSION_LESS_THAN_OR_EQUAL_TO(v)     ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] != NSOrderedDescending)

#import "v0rtex.h"
#import <UIKit/UIKit.h>

@interface FocusedButton : UIButton

@property(nonatomic, strong) UIColor *focusColor;
@property(nonatomic, strong) UIColor *unfocusedColor;

- (void)buttonColors:(UIColor *)focusedColor andUnfocused:(UIColor *)unfocusedColor;

@end

@interface ViewController : UIViewController

- (void)_updateDateCheck;
- (NSString *)_lastCheckDate;
-(BOOL)_shouldCheckUpdate;
- (void)checkForUpdate;

+ (instancetype)currentViewController;
- (void)removingLiberiOS;
- (void)removingElectraBeta;
- (void)installingNitoTV;
- (void)nitoTVDone;
- (void)displaySnapshotNotice;
- (void)displaySnapshotWarning;
- (void)writeText:(NSString *)message;
- (void)writeTextPlain:(NSString *)message, ...;

@end


task_t tfp0;
kptr_t kslide;
kptr_t kernel_base;
kptr_t kern_ucred;
kptr_t kernprocaddr;

void log_message(NSString *message);


